/* 
 * Copyright (C) 2008 Laird Breyer
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author:   Laird Breyer <laird@lbreyer.com>
 */

#ifndef PPMWRITER_H
#define PPMWRITER_H

#include "common.h"
#include <unistd.h>
#include <stdio.h>

typedef struct {
  int fd;
  FILE *f;
  imagetype_t type;
  unsigned int colors;
  unsigned long imagesize;
  unsigned long byteswritten;
} ppmwriter_t;

bool_t create_ppmwriter(ppmwriter_t *p, int fd, imagetype_t typ);
bool_t free_ppmwriter(ppmwriter_t *p);

bool_t write_header_ppmwriter(ppmwriter_t *p, 
			      unsigned int width, unsigned int height,
			      unsigned int colors, imagetype_t typ);
bool_t write_pixels_ppmwriter(ppmwriter_t *p, 
			      byte_t *buf, unsigned int buflen);
int printf_ppmwriter(ppmwriter_t *p, const char *format, ...);


bool_t endl_ppmwriter(ppmwriter_t *p);
bool_t consistency_check_ppmwriter(ppmwriter_t *p);



#endif
